Subject: Re: Git 3.0?

From: Patrick Steinhardt <[email-masked]>
Date: Tue, 7 May 2024 06:18:20 +0200

On Mon, May 06, 2024 at 02:33:33PM -0700, Junio C Hamano wrote:
> Junio C Hamano <[email-masked]> writes:
> 
> > Patrick Steinhardt <[email-masked]> writes:
> >
> >> ... I was pondering
> >> whether we want to introduce a document as part of that patch series
> >> that starts to keep track of upcoming removals for a potential Git 3.0
> >> release.
> >
> > Finally somebody has bit it ;-)  In the 2.44 cycle, I wrote
> >
> >     The RelNotes symbolic link says we are now working towards Git 2.44.
> >     It may not be a bad idea to reflect on what technical debt and UI
> >     warts we have accumulated so far to see if we have enough of them to
> >     start planning for a breaking Git 3.0 release (or, of course, keep
> >     incrementally improve the system, which is much more preferrable---
> >     continuity and stability is good).  End of year being a relatively
> >     quiet period, it may be a good time to think about your favorite pet
> >     peeve, to be discussed early next year.
> >
> > in a few of the "What's cooking" reports.
> >
> >> There are multiple items that could be added:
> >>
> >>   - Removal of the old syntax of git-config(1).
> >>
> >>   - Removal of the dumb HTTP transport.
> >>
> >>   - Removal of `info/grafts`.
> >>
> >> There are probably other items.
> > 
> > A list of things I can think of that I won't be the primary advocate
> > for but I do not mind too terribly if we had champions for the
> > topics are attached at the end.
> 
> Just to avoid unnecessary misunderstanding, as I said, what I listed
> are not my proposals.  Rather, take them together with Patrick's list
> that they are invitations for others to let their imagination go wild,
> trying to come up as many ideas regardless of how good they are, sort
> of the initial "brain-storming" phase of a discussion.  We will need
> to cull bad ideas, pick good ones, and refine what we are going to
> implement in later stages, but this is not a time to shoot down what
> you do not like, yet.  It is instead for you to add your pet peeve.

Just to avoid starting this discussion deep down in this thread, I plan
to send an RFC-style patch later today that proposes several potential
deprecations for Git 3.0. The intent of that patch will be to trigger
discussion and it is thus by design going to be controversial :)

Patrick